controllers.controller('videoPlayerController', ['$scope', 'apiFactory', 'stageSize', 'userStorage', 'platformType', '$timeout', '$rootScope', 'analyticsService', function ($scope, apiFactory, stageSize, userStorage, platformType, $timeout, $rootScope, analyticsService) {

	//assign platformType object to be visible in html template
    $scope.platformType = platformType;

	//default video player variables
    $scope.playerVars = {
        'autoplay': 1,
        'controls': 0,
        'enablejsapi': 1,
        'modestbranding': 1,
        'showinfo': 0,
        'rel': 0,
        'scrolling': 0,
        'wmode': 'opaque',
        'html5': 1
    };
	
	//call to create video player and assign callback functions
    $scope.createVideoPlayer = function( videoId ) {

        var playerConfigObject = {
            width: '100%',
            height: '100%',
            playerVars: $scope.playerVars,
            events: {
                'onReady': $scope.onPlayerReady,
                'onStateChange': $scope.onPlayerStateChange
            }
        };

		//if videoId is present, create player and load passed videoId
        if( videoId ){
            playerConfigObject.videoId = videoId;
        }

		//create YT player and assign object to $scope.player variable
        $scope.player = new YT.Player('player', playerConfigObject );
    };

    $scope.onPlayerStateChange = function (event) {
        var state = $scope.player.getPlayerState();
        switch(state){
			//this is triggered when player is loaded but unstarted
			//event is triggered only once on startup when player loads 
			//we change playerInit value and tell framework to remove class and bring player to background again
            case -1:
                $scope.playerInit = true;
                userStorage.getData().videoPlaying = false;
                break;
        }

        $rootScope.$broadcast(Events.Video.PLAYER_STATE_CHANGE, state );
        $scope.$evalAsync();
    };
}]);